#ifndef ColorSelectionFrame_p_h
#define ColorSelectionFrame_p_h

// $Id: ColorSelectionFrame_p.h,v 1.1 2013/02/22 12:05:50 hupereir Exp $

/******************************************************************************
*
* Copyright (C) 2002 Hugo PEREIRA <mailto: hugo.pereira@free.fr>
*
* This is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
*
* This software is distributed in the hope that it will be useful, but WITHOUT
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
* for more details.
*
* You should have received a copy of the GNU General Public License along with
* software; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA  02111-1307 USA
*
*
*******************************************************************************/

#include "Counter.h"

#include <QFrame>
#include <QPushButton>

namespace PRIVATE
{
    class ColorWidget: public QPushButton, public Counter
    {

        Q_OBJECT

            public:

            //! constructor
            ColorWidget( QWidget* parent = 0 );

        signals:

        // emmited when new color is selected
        void colorSelected( QString );

    };

    class ColorDisplay: public QFrame, public Counter
    {

        public:

        //! constructor
        ColorDisplay( QWidget* parent = 0 );

        //! color
        void setColor( const QColor& color );

        protected:

        //! paint
        virtual void paintEvent( QPaintEvent* );

        private:

        QColor color_;

    };

}
#endif
